#include <avr/io.h>
#include <util/delay.h>
#include "music.h"

static int frecventa_nota[NUM_NOTE] = {
	262, 294, 330, 349, 392, 440, 494, 523, 587,
	659, 698, 784, 880, 988, 1046, 466, 932, 830, 622
};

/* Genereaza o nota folosind buzzer-ul. */
static void buzzer_reda(int nota, int durata) {
	int perioada_nota = 1000000 / frecventa_nota[nota];
	int i, j;

	/*
	 * Nu putem folosi variable ca argument pentru functia
	 * _delay_us(), asa ca folosim acest "workaround".
	 */
	
	for (j = 0; j < durata; j++) {
		PORTA |= (1 << PA0);	
		for (i = 0; i < perioada_nota / 2; ++i)
			_delay_us(1);

		PORTA &= ~(1 << PA0);
		for (i = 0; i < perioada_nota / 2; ++i)
			_delay_us(1);
	}
}

void play_win_song()
{
	int seq [] = {FA1, MI1, FA1, MI1, DO1, LA, RE1, LA, DO1,
				FA1, SOL1, LA1, DO2, LA1, RE1, MI1, RE1};
	int seq1 [] = {RE1, DO1, RE1, DO1, SIb, SIB, LA1, SIB, LA1, SOL1,
				LA1, FA1, SIB, LA1, FA1, SIB, LAB, FA1, SIB, LAB, FA1,
				MIB, DO1, FA1};

	DDRA |= (1 << PA0);
	PORTA &= ~(1 << PA0);
	
	while (1) {
		buzzer_reda(seq[0], D);
		_delay_ms(PAUSE);
		buzzer_reda(seq[1], O);
		_delay_ms(PAUSE);
		buzzer_reda(seq[2], O);
		_delay_ms(PAUSE);
		buzzer_reda(seq[3], P);
		_delay_ms(PAUSE);
		buzzer_reda(seq[4], P);
		_delay_ms(PAUSE);
		buzzer_reda(seq[5], O);
		_delay_ms(PAUSE);
		buzzer_reda(seq[6], O);
		_delay_ms(PAUSE);
		buzzer_reda(seq[7], D);
		_delay_ms(PAUSE);
		buzzer_reda(seq[8], O);
		_delay_ms(PAUSE);
		buzzer_reda(seq[9], D);
		_delay_ms(PAUSE);
		buzzer_reda(seq[10], O);
		_delay_ms(PAUSE);
		buzzer_reda(seq[11], O);
		_delay_ms(PAUSE);
		buzzer_reda(seq[12], D);
		_delay_ms(PAUSE);
		buzzer_reda(seq[13], P);
		_delay_ms(PAUSE);
		buzzer_reda(seq[14], O);
		_delay_ms(PAUSE);
		buzzer_reda(seq[15], O);
		_delay_ms(PAUSE);
		buzzer_reda(seq[16], D);
		_delay_ms(PAUSE); 
		buzzer_reda(seq1[0], P);
		_delay_ms(PAUSE);
		buzzer_reda(seq1[1], O);
		_delay_ms(PAUSE);
		buzzer_reda(seq1[2], O);
		_delay_ms(PAUSE);
		buzzer_reda(seq1[3], P);
		_delay_ms(PAUSE);
		buzzer_reda(seq1[4], P);
		_delay_ms(PAUSE);	
		buzzer_reda(seq1[5], D);
		_delay_ms(PAUSE);		
		buzzer_reda(seq1[6], P);
		_delay_ms(PAUSE);		
		buzzer_reda(seq1[7], P);
		_delay_ms(PAUSE);		
		buzzer_reda(seq1[8], D);
		_delay_ms(PAUSE);		
		buzzer_reda(seq1[9], D);
		_delay_ms(PAUSE);
		buzzer_reda(seq1[10], D);
		_delay_ms(PAUSE);		
		buzzer_reda(seq1[11], P);
		_delay_ms(PAUSE);		
		buzzer_reda(seq1[12], P);
		_delay_ms(PAUSE);
		buzzer_reda(seq1[13], D);
		_delay_ms(PAUSE);		
		buzzer_reda(seq1[14], P);
		_delay_ms(PAUSE);		
		buzzer_reda(seq1[15], P);
		_delay_ms(PAUSE);		
		buzzer_reda(seq1[16], D);
		_delay_ms(PAUSE);		
		buzzer_reda(seq1[17], P);
		_delay_ms(PAUSE);
		buzzer_reda(seq1[18], P);
		_delay_ms(PAUSE);
		buzzer_reda(seq1[19], D);
		_delay_ms(PAUSE);
		buzzer_reda(seq1[20], D);
		_delay_ms(PAUSE * 10);
		buzzer_reda(seq1[21], O);
		_delay_ms(PAUSE);
		buzzer_reda(seq1[22], O);
		_delay_ms(PAUSE);
		buzzer_reda(seq1[23], D * 2);
		_delay_ms(PAUSE * 10);
	}

}