/*#include <avr/io.h>
#include <util/delay.h>
 
int main() {
	// Setez pinii ca iesire.
	DDRC |= (1 << PC0) | (1 << PC1) | (1 << PC2) | (1 << PC3) | (1 << PC4) | (1 << PC5) | (1 << PC6);
	DDRA |= (1 << PA0) | (1 << PA1) | (1 << PA2) | (1 << PA3) | (1 << PA4) | (1 << PA5) | (1 << PA6) | (1 << PA7);
	// Setez pinii de intrare. 
	DDRB &= ~((1 << PB3) | (1 << PB4) | (1 << PB5) | (1 << PB6));
	// Activez rezistenta de pull-up pentru pinul PB2.
	PORTB |= (1 << PB3) | (1 << PB4) | (1 << PB5) | (1 << PB6);

	while (1) {
		if ((PINB & (1 << PB3)) == 0) {
			//sting albastre
			PORTA &= ~(1 << PA2);
			PORTA &= ~(1 << PA5);
			PORTC &= ~(1 << PC6);
			PORTC &= ~(1 << PC3);
			PORTC &= ~(1 << PC0);
		}
		else {
			//aprind rosii
			PORTA |= (1 << PA0);
			PORTA |= (1 << PA3);
			PORTA |= (1 << PA6);
			PORTC |= (1 << PC5);
			PORTC |= (1 << PC2);
		}
		//_delay_ms(5000);
		if ((PINB & (1 << PB4)) == 0) {
			//sting rosii
			PORTA &= ~(1 << PA0);
			PORTA &= ~(1 << PA3);
			PORTA &= ~(1 << PA6);
			PORTC &= ~(1 << PC5);
			PORTC &= ~(1 << PC2);
		}
		else {
			//aprind verzi
			PORTA |= (1 << PA1);
			PORTA |= (1 << PA4);
			PORTA |= (1 << PA7);
			PORTC |= (1 << PC4);
			PORTC |= (1 << PC1);
		}
		//_delay_ms(5000);
		if ((PINB & (1 << PB6)) == 0) {
			//sting verzi
			PORTA &= ~(1 << PA1);
			PORTA &= ~(1 << PA4);
			PORTA &= ~(1 << PA7);
			PORTC &= ~(1 << PC4);
			PORTC &= ~(1 << PC1); 
		}
		else {
			//aprind albastre
			PORTA |= (1 << PA2);
			PORTA |= (1 << PA5);
			PORTC |= (1 << PC6);
			PORTC |= (1 << PC3);
			PORTC |= (1 << PC0);
		}
		//_delay_ms(5000);
	}
	return 0;
}*/

#include <avr/io.h>
#include <util/delay.h>
#include "spi.h"
#include "ST7735R_TFT.h"

#define MORSE_LUNG		150
#define MORSE_SCURT		50
#define MORSE_PAUZA		50
#define BUTON_NEGRU		PD1

// Genereaza sunetul pentru tipul de ton folosit: lung (150ms) sau scurt (50ms).
void speaker_morse(int tip_morse) {
	int i;
	// Alternam starea pinului PD4 la fiecare milisecunda.
	for (i = 0; i < tip_morse; ++i) {
		PIND = (1 << PD0);
		_delay_ms(1);
	}
}

void task2(void) {
	// Setez pinii PD1 si PD2 ca intrare.
	DDRD &= ~((1 << BUTON_NEGRU) | (1 << PD4));

	// Activez rezistenta de pull-up pentru pinii PD1 si PD2.
	PORTD |= (1 << BUTON_NEGRU) | (1 << PD4);

	// Setez pinii ca iesire. 
	DDRD |= (1 << PD0);
	DDRA |= (1 << PA0) | (1 << PA1) | (1 << PA2);

	// Opresc speaker-ul.
	PORTD &= ~(1 << PD0);
	//sting ledurile
	PORTA &= ~(1 << PA0);
	PORTA &= ~(1 << PA1);

	// Init SPI for LCD.
    	SPI_init();

    	// Init LCD
    	ST7735R_Begin();

    	// Enable interrupts.
    	//sei();

    	// Clear screen with BLACK.
    	ST7735R_FillRect(0, 0, ST7735R_WIDTH - 1, ST7735R_HEIGHT - 1, 0, 0, 0);

	while (1) {
		if ((PIND & (1 << BUTON_NEGRU)) == 0) {
			PORTA |= (1 << PA0);
			ST7735R_FillRect(0, 0, ST7735R_WIDTH - 1, ST7735R_HEIGHT - 1, 0, 0, 0);
			//SWORD
			//sharp point
			ST7735R_Line(10, 24, 20, 20, 255, 255, 255);
			ST7735R_Line(10, 24, 20, 28, 255, 255, 255);
			//long blade
			ST7735R_Line(20, 20, 85, 20, 255, 255, 255);
			ST7735R_Line(10, 24, 85, 24, 255, 255, 255);			
			ST7735R_Line(20, 28, 85, 28, 255, 255, 255);
			//handle bottom
			ST7735R_FillRect(85, 15, 91, 33, 255, 255, 255);
			//handle
			ST7735R_Line(91, 21, 111, 21, 255, 255, 255);
			ST7735R_Line(91, 27, 111, 27, 255, 255, 255);
			ST7735R_FillRect(96, 21, 101, 27, 255, 255, 255);
			ST7735R_FillRect(106, 21, 111, 27, 255, 255, 255);

			//TITLE
			ST7735R_DrawText(46, 45, "A GAME\0", 255, 255, 255, 0, 0, 0);
			ST7735R_DrawText(62, 60, "OF\0", 255, 255, 255, 0, 0, 0);
			ST7735R_DrawText(45, 75, "THRONES\0", 255, 255, 255, 0, 0, 0);
			
			//MENU
			ST7735R_Line(25, 108, 103, 108, 255, 255, 255);
			ST7735R_DrawText(49, 115, "START\0", 255, 255, 255, 0, 0, 0);
			ST7735R_Line(25, 126, 103, 126, 255, 255, 255);
			ST7735R_DrawText(31, 137, "INSTRUCTIONS\0", 255, 255, 255, 0, 0, 0);
			ST7735R_Line(25, 149, 103, 149, 255, 255, 255);
			//_delay_ms(120);
			//speaker_morse(MORSE_SCURT);
		}
		else if ((PIND & (1 << PD4)) == 0) {
			PORTA |= (1 << PA1);
			ST7735R_FillRect(0, 0, ST7735R_WIDTH - 1, ST7735R_HEIGHT - 1, 0, 0, 0);			
			ST7735R_DrawText(1, 50, "WOW DEJA E PREA BINE!!!!\0", 255, 255, 255, 0, 0, 0);
			//_delay_ms(120);
			speaker_morse(MORSE_LUNG);
		}
		PORTA &= ~(1 << PA0);
		PORTA &= ~(1 << PA1);
		PORTD &= ~(1 << PD0);
		_delay_ms(120);
	}
}

int main(void) {
	task2();

	while (1);

	return 0;
}